//////////////////////////////////////////////////////////////////////
//  - readonly                                                      //
//    ʵ带 б .                                   //
//                                                                  //
//  - required                                                      //
//    ʵ带 ʼԷ .                                   //
//                                                                  //
//  - right                                                         //
//    ʵ峻 text-alignment  Ѵ.                  //
//                                                                  //
//  - center                                                        //
//    ʵ峻 text-alignment ߾ķ Ѵ.                      //
//                                                                  //
//  - filter="[abcde-y]"                                            //
//                                                                  //
//  - mask="999-999"                                                //
//                                                                  //
//  - money                                                         //
//    ݾ Է ʵ带  Ǹ ڸ ޸(,) ȴ//
//                                                                  //
//  - date                                                          //
//    ڸ Էϴ ʵ  Ѵ.                         //
//                                                                  //
//  - number="(x,x)"                                                //
//   Ŭ db number(5,2)ǥõ ׸ number="(5,2)" ǥ     //
//                                                                  //
//  - number                                                        //
//   ڿ   [0-9]  ڸ Էµȴ.             //
//                                                                  //
//////////////////////////////////////////////////////////////////////
var SUCCESS = 0;
var ERR_REQUIRED = 10;
var ERR_FORMAT = 20;
var ERR_DATE = 30;
var ERR_NUMBER = 40;
var ERR_MAXLENGTH = 50;
var ERR_JUMIN = 60;
var ERR_MAIL = 70;
var ERR_COMP = 80;
var ERR_TEL = 90;

var MSG_ERR010 = "ʼ Է Դϴ";
var MSG_ERR020 = "߸ Է Դϴ.";
var MSG_ERR030 = "¥ Է ߸Ǿϴ.";
var MSG_ERR040 = " Է ߸Ǿϴ.";
var MSG_ERR050 = "ִ Է ڸ ʰ߽ϴ.";
var MSG_ERR060 = "ùٸ ֹεϹȣ ƴմϴ.";
var MSG_ERR070 = "ùٸ  ּҰ ƴմϴ.";
var MSG_ERR080 = "ùٸ  Ϲȣ ƴմϴ.";
var MSG_ERR090 = "ùٸ ȭȣ ƴմϴ.";
var MSG_ERR100 = "  Դϴ. ݵðڿ Ͻʽÿ";

var TYPE_NONE = 0;
var TYPE_MONEY = 10;
var TYPE_MONEY2 = 11;
var TYPE_DATE = 20;
var TYPE_MASK = 30;
var TYPE_NUMBER = 40;
var TYPE_JUMIN = 50;
var TYPE_MAIL = 60;
var TYPE_COMP = 70;
var TYPE_TEL = 80;
///////////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////////
// Լ : f_validate()
//    :  Է   Է üũ
//          Select ʼԷ¿θ ˻Ѵ.
// Object : element
///////////////////////////////////////////////////////////////////////////////
function f_validate()
{
    if ( this.getAttribute("required") != null && isBlank(this) ) return ERR_REQUIRED;

    switch(this.iType){
        case TYPE_MONEY :
            if(!isValid(this)) return ERR_NUMBER;
            break;
        case TYPE_MONEY2 :
            if(!isValid(this)) return ERR_NUMBER;
            break;
        case TYPE_DATE :
            if(!isDate(this)) return ERR_DATE;
            break;
        case TYPE_MASK :
            if(!isValid(this)) return ERR_FORMAT;
            break;
        case TYPE_NUMBER :
            if(!isValid(this)) return ERR_NUMBER;
            break;
        case TYPE_JUMIN :
            if(!isJumin(this)) return ERR_JUMIN;
            break;
        case TYPE_COMP :
            if(!isComp(this)) return ERR_COMP;
            break;
        case TYPE_MAIL :
            if(!isMail(this)) return ERR_MAIL;
            break;
        case TYPE_TEL :
            if(!isTel(this)) return ERR_TEL;
            break;
        case TYPE_NONE :
            if(!isValid(this)) return ERR_FORMAT;
            if(!isLength(this)) return ERR_MAXLENGTH;
            break;
    }

    return SUCCESS;
}

///////////////////////////////////////////////////////////////////////////////
// Լ : f_validate_display()
//    : Է° üũ   ó
// Object : element
///////////////////////////////////////////////////////////////////////////////
function f_validate_display()
{
    var ret = this.validate();
    var msg = "";

    switch(ret){
        case SUCCESS :
                    //if(this.getAttribute("readonly"))
                    //    this.style.backgroundColor = "#E8E8E8";
                    //else
                    //    this.style.backgroundColor = "";
                    return true;
        case ERR_REQUIRED :
                    msg = MSG_ERR010;
                    break;
        case ERR_DATE:
                    msg = MSG_ERR030;
                    break;
        case ERR_JUMIN:
                    msg = MSG_ERR060;
                    break;
        case ERR_COMP:
                    msg = MSG_ERR080;
                    break;
        case ERR_MAIL:
                    msg = MSG_ERR070;
                    break;
        case ERR_TEL:
                    msg = MSG_ERR090;
                    break;
        case ERR_FORMAT :
                    msg = MSG_ERR020;
                    if(this.getAttribute("mask"))
                        msg += " ["+this.getAttribute("mask")+"]";
                    if(this.getAttribute("filter"))
                        msg += " 밪"+this.getAttribute("filter");
                    break;
        case ERR_NUMBER :
                    msg = MSG_ERR040;
                    if(this.getAttribute("number"))
                        msg += " "+this.getAttribute("number");
                    break;
        case ERR_MAXLENGTH :
                    msg = MSG_ERR050 + "[ִڸ:"+this.getAttribute("MAXLENGTH")+"]";
                    break;
        default :
                    msg = MSG_ERR100;
                    break;
    }


    if(this.getAttribute("msg2"))
	    alert("< " + this.getAttribute("msg") + " >" + this.getAttribute("msg2"));
    else if(this.getAttribute("msg"))
        alert("< " + this.getAttribute("msg") + " >..." + msg);
	else
        alert(msg);

    this.style.backgroundColor = "YELLOW";
    if(this.focus) this.focus();

    return false;
}

///////////////////////////////////////////////////////////////////////////////
// Լ : f_onkeypress()
//    : ŰԷ óϱ ڵ鷯
// Event : onKeyPress
// Object : element
///////////////////////////////////////////////////////////////////////////////
function f_onkeypress() {
    var sFilter = this.getAttribute("filter");

    if(this.oldkeypress)
        this.oldkeypress();

    if(String.fromCharCode(event.keyCode) == "\r") {
        event.returnValue = false;
    } else if(sFilter){
        var sKey = String.fromCharCode(event.keyCode);
        var re = new RegExp(sFilter);
        if(!re.test(sKey)) event.returnValue = false;
    }
}

///////////////////////////////////////////////////////////////////////////////
// Լ : f_onfocus()
//    :  element focus  ̺Ʈڵ鷯
// Event  : onFocus
// Object : element
///////////////////////////////////////////////////////////////////////////////
function f_onfocus()
{
    if(this.readOnly) return;

    toUnformat(this);
    if(this.select) this.select();
}

///////////////////////////////////////////////////////////////////////////////
// Լ : f_onblur()
//    :  element blur  ̺Ʈڵ鷯
// Event  : onBlur
// Object : element
///////////////////////////////////////////////////////////////////////////////
function f_onblur()
{
    if(this.oldblur)
        this.oldblur();

    toFormat(this);
}

///////////////////////////////////////////////////////////////////////////////
// Լ : f_onsubmit()
//    : Form Է° Submit üũ  Լ
// Event : onSubmit
// Object : Form
///////////////////////////////////////////////////////////////////////////////
function f_onsubmit()
{
    for(var i = 0; i < this.elements.length; i++){
        if(this.elements[i].validate) {
            if(!this.elements[i].validate_display()){
                return false;
            }
        }
    }

    if(this.oldSubmit && !this.oldSubmit())
        return false;

    for(var i = 0; i < this.elements.length; i++)
        toUnformat(this.elements[i]);

    for(var i = 0; i < this.elements.length; i++)
        if(this.elements[i].disabled)
            this.elements[i].disabled = false;

    this.submit();

    for(var i = 0; i < this.elements.length; i++)
        toFormat(this.elements[i]);

    return true;
}


///////////////////////////////////////////////////////////////////////////////
// Լ : setField()
//    : field Ư   Ӽ,̺Ʈ 
///////////////////////////////////////////////////////////////////////////////
function setField(obj) {
  if (obj.type) {
    var required = obj.getAttribute("required");
    var number = obj.getAttribute("number");
    var money = obj.getAttribute("money");
    var money2 = obj.getAttribute("money2");
    var date = obj.getAttribute("date");
    var jumin = obj.getAttribute("jumin");
    var comp = obj.getAttribute("comp");
    var mail = obj.getAttribute("mail");
    var mask = obj.getAttribute("mask");
    var tel = obj.getAttribute("tel");
    var fcs = obj.getAttribute("fcs");

    switch( obj.type ) {
      case "text" :
        if(money != null) {
          obj.iType = TYPE_MONEY;
          obj.style.textAlign = "right";
          obj.setAttribute("filter","[,0-9]");
          obj.style.imeMode = "inactive";
		} else if(money2 != null) {
          obj.iType = TYPE_MONEY2;
          obj.style.textAlign = "right";
          obj.setAttribute("filter","[-,0-9]");
          obj.style.imeMode = "inactive";
        } else if(date != null) {
          obj.iType = TYPE_DATE;
          obj.style.textAlign = "center";
          obj.setAttribute("filter","[0-9]");
          if(!mask)
            obj.setAttribute("mask","9999-99-99");
          obj.style.imeMode = "inactive";
        } else if(number != null) {
          obj.iType = TYPE_NUMBER;
          obj.style.textAlign = "right";
          if(number)
            obj.setAttribute("filter","[.0-9]");
          else
            obj.setAttribute("filter","[0-9]");
          obj.style.imeMode = "inactive";
        } else if(jumin != null) {
          obj.iType = TYPE_JUMIN;
          obj.style.textAlign = "center";
          obj.style.imeMode = "inactive";
          obj.setAttribute("filter","[0-9]");
          obj.setAttribute("mask","999999-9999999");
        } else if(comp != null) {
          obj.iType = TYPE_COMP;
          obj.style.textAlign = "center";
          obj.style.imeMode = "inactive";
          obj.setAttribute("filter","[0-9]");
          obj.setAttribute("mask","999-99-99999");
        } else if(mail != null) {
          obj.iType = TYPE_MAIL;
          obj.style.imeMode = "inactive";
          obj.setAttribute("filter","[a-zA-Z0-9.@\\-_]");
        } else if(tel != null) {
          obj.iType = TYPE_TEL;
          obj.style.imeMode = "inactive";
          obj.setAttribute("filter","[0-9-]");
        } else if(mask) {
          obj.iType = TYPE_MASK;
        } else {
          obj.iType = TYPE_NONE;
        }
      case "password" :
      case "file" :
        if(required != null ) {
          obj.style.backgroundImage="url(/SFA/images/required.gif)";
          obj.style.backgroundPosition="top right";
          obj.style.backgroundRepeat="no-repeat";
        }

        obj.oldkeypress = obj.onkeypress;
        obj.onkeypress = f_onkeypress;
        obj.onfocus = f_onfocus;
        obj.oldblur = obj.onblur;
        obj.onblur = f_onblur;
      case "select-one":
        obj.validate = f_validate;
        obj.validate_display = f_validate_display;
        break;
      case "textarea" :
        break;
      default:
        break;
    }
  }

  if(obj.getAttribute("readonly")) {
    //obj.style.backgroundColor = "#E8E8E8";
    obj.tabIndex = -1;
  }

  if( obj.getAttribute("left") != null )
    obj.style.textAlign = "left";
  if( obj.getAttribute("right") != null )
    obj.style.textAlign = "right";
  if( obj.getAttribute("center") != null )
    obj.style.textAlign = "center";

  if( obj.type != "hidden")
    toFormat(obj);

  if(fcs != null)
    obj.focus();
}

function f_ondragstart() {
  return false;
}

function f_onselectstart() {
  return false;
}

function f_oncontextmenu() {
  return false;
}

///////////////////////////////////////////////////////////////////////////////
// Լ : init()
//    : Body Loadɶ Form  Elements Attribute  EventHandler
///////////////////////////////////////////////////////////////////////////////
function inits() {
//    document.onselectstart = f_onselectstart;  //콺 ܴ(select)  
//    document.ondragstart = f_ondragstart;      //ŬϿ 콺 巡 
//    document.oncontextmenu = f_oncontextmenu;  //콺  ư 

    for(var f = 0; f < document.forms.length; f++){
        var mForm =  document.forms[f];
        var iElements = mForm.elements.length;

        for(var i = 0; i < iElements; i++)
            setField(mForm.elements[i]);

        mForm.oldSubmit = mForm.onsubmit;
        mForm.onsubmit = f_onsubmit;
    }

    if(document.all && document.all.tags("BLINK").length > 0)
        setInterval("setBlink()",500);
}